<!DOCTYPE html>
<html>
<head>

<meta charset='utf-8'>
<title> Ćwiczenia I-V </title>

<script type='text/javascript' src='shapes.js'></script>
<script type='text/javascript' src='gl-matrix-min.js'></script> <!-- To jest biblioteka do operacji macierzowych -->



<style>
body {
  background-color: #111111;
  color: white;
}
div { text-align: center; }
canvas {
  border-color: white;
  border-style: solid;
  border-radius: 1em;
}

.panels { display: table; }
.panels div { display: table-cell; }

.table { display: table; }
.header {
  display: table-row;
  position: relative;
  text-align: center;
  width: 60em;
}
.row { display: table-row; }
.cell {
  display: table-cell;
  vertical-align: top;
  text-align: left;
  width: 20em;
}
.half_cell < .cell {
  width: 40em;
}

textarea {
  width: 4em;
  height: 1.2em;
  background: #222222;
  color: #FF1144;
  resize: none;
}
#textarea_15 { width: 15em; }

input[type=checkbox] {
  width: 3em;
  height: 3em;
  vertical-align: middle;
  background: white;
  -moz-appearance: none;
}

input[type=range] {
  width: 8em;
  -webkit-appearance: none;
  -moz-appearance: none;
}
input[type=range]::-moz-range-thumb,
input[type=range]::-webkit-slider-thumb {
  color: red;
  background: red;
  -webkit-appearance: none;
  -moz-appearance: none;
}
input[type=range]:focus::-moz-slider-track,
input[type=range]:focus::-webkit-slider-runnable-track {
  color: red;
  background: red;
  -webkit-appearance: none;
  -moz-appearance: none;
}
input[type=range].vertical {
  margin-top: 50px;
  transform: rotate(270deg);
  -moz-transform: rotate(270deg);
}
</style>



<script type='text/x-vertex' id='vertex-shader-I'>
attribute vec4 aPosition;
attribute vec4 aColor;
attribute vec3 aNormal;
attribute vec2 aTexture;
uniform mat4 uMVP;
uniform mat4 uMV;
uniform mat3 uMV_normal;
uniform vec4 uLightPositionInViewSpace;
uniform vec3 uAttenuationCoefficient;
uniform bool uIsLamp;
uniform bool uUseSpecular;
uniform float uMaterialShininess;
varying vec4 vColor;
varying vec2 vTexture;
varying float vLight;
void main(void) {
  vColor = aColor;
  vTexture = aTexture;
  gl_Position = uMVP * aPosition;
  gl_PointSize = 10.0;

  vec3 normalInViewSpace   = normalize(uMV_normal * aNormal);
  vec3 positionInViewSpace = (uMV * aPosition).xyz;
  vec3 lightVector         = uLightPositionInViewSpace.xyz - positionInViewSpace;

  float distanceToLight = length(lightVector);
  float attenuation =
    1.0 / (
      uAttenuationCoefficient[0] +
      distanceToLight * ( uAttenuationCoefficient[1] + distanceToLight * uAttenuationCoefficient[2] )
    );

  lightVector = attenuation * lightVector / distanceToLight;

  if ( ! uIsLamp ) {
    vLight = max(0.0, dot(normalInViewSpace, lightVector));
    if ( uUseSpecular ) {
      vec3 normal              = normalize( normalInViewSpace );
      vec3 eyeDirection        = normalize( - positionInViewSpace.xyz );
      vec3 reflectionDirection = reflect( - lightVector, normal );
      float specularLightWeighting =
        pow(
          max( dot( reflectionDirection, eyeDirection ), 0.0 ),
          uMaterialShininess
        );
        //attenuation * pow( max( reflect( - lightVector, vNormalInViewSpace), vec3(0.0, 0.0, 0.0)), materialShininess );
      vLight +=
        //uAmbientColor +
        /*uLightColor * */specularLightWeighting;
    }
  }
  else vLight = 1.0;
}
</script>
<script type='text/x-fragment' id='fragment-shader-I'>
precision mediump float;
uniform sampler2D uTexture;
uniform vec3 uLightColor;
uniform bool uUseTexture;
varying vec4 vColor;
varying vec2 vTexture;
varying float vLight;
void main(void) {
  //gl_FragColor = vec4(0.5, 0, 0, 1);
  //gl_FragColor = texture2D(uTexture, vTexture);
  if ( uUseTexture ) {
    gl_FragColor.rgb = texture2D(uTexture, vTexture).rgb * vLight * uLightColor.rgb;
  }
  else {
    gl_FragColor.rgb = vColor.rgb * vLight * uLightColor.rgb;    
  }
  gl_FragColor.a = 1.0;
}
</script>

<script type='x-shader/x-vertex' id='PFL-vertex-shader'>
attribute vec4 aPosition;
attribute vec4 aColor;
attribute vec3 aNormal;
attribute vec2 aTexture;
uniform mat4 uMVP;
uniform mat4 uMV;
uniform mat3 uMV_normal;
varying vec4 vPosition;
varying vec4 vColor;
varying vec3 vPositionInViewSpace;
varying vec3 vNormalInViewSpace;
varying vec2 vTexture;
void main(void) {
  vColor = aColor;
  vTexture = aTexture;
  vPositionInViewSpace = (uMV * aPosition).xyz;
  vNormalInViewSpace = normalize(uMV_normal * aNormal);
  gl_Position = uMVP * aPosition;
  gl_PointSize = 10.0;
}
</script>
<script type='x-shader/x-fragment' id='PFL-fragment-shader'>
precision mediump float;
uniform sampler2D uTexture;
uniform vec4 uLightPositionInViewSpace;
uniform vec3 uLightColor;
uniform bool uIsLamp;
uniform bool uUseSpecular;
uniform bool uUseTexture;
uniform float uMaterialShininess;
uniform vec3 uAttenuationCoefficient;
varying vec4 vColor;
varying vec3 vPositionInViewSpace;
varying vec3 vNormalInViewSpace;
varying vec2 vTexture;
void main(void) {
  vec3 lightVector = uLightPositionInViewSpace.xyz - vPositionInViewSpace;

  float distanceToLight = length(lightVector);
  float attenuation =
    1.0 / (
      uAttenuationCoefficient[0] +
      distanceToLight * ( uAttenuationCoefficient[1] + distanceToLight * uAttenuationCoefficient[2] )
    );

  lightVector = attenuation * lightVector / distanceToLight;

  float vLight;
  if ( ! uIsLamp ) {
    vLight = max( 0.0, dot( vNormalInViewSpace, lightVector ) );
    if ( uUseSpecular ) {
      vec3 normal = normalize( vNormalInViewSpace );
      vec3 eyeDirection = normalize( - vPositionInViewSpace.xyz );
      vec3 reflectionDirection = reflect( - lightVector, normal );
      float specularLightWeighting =
        pow(
          max( dot( reflectionDirection, eyeDirection ), 0.0 ),
          uMaterialShininess
        );
        //attenuation * pow( max( reflect( - lightVector, vNormalInViewSpace), vec3(0.0, 0.0, 0.0)), materialShininess );
      vLight +=
        //uAmbientColor +
        /*uLightColor * */specularLightWeighting;
    }
  }
  else vLight = 1.0;

  if ( uUseTexture ) {
    gl_FragColor.rgb = texture2D(uTexture, vTexture).rgb * vLight * uLightColor.rgb;    
  }
  else {
    gl_FragColor.rgb = vColor.rgb * vLight * uLightColor.rgb;
  }
  gl_FragColor.a = 1.0;
}
</script>



<script type='text/javascript'>

function getTextFromTag( id ) {
  var tag = document.getElementById(id);
  if ( ! tag ) return null; //////////////////////////////////////////////////

  var str = '';
  var k = tag.firstChild;
  while (k) {
    if (k.nodeType == Node.TEXT_NODE) str += k.textContent;
    k = k.nextSibling;
  }
  return str;
}
function checkError( gl, msg ) {
  var info = gl.getError();
  if (info != gl.NO_ERROR) console.log('Error ' + info + ' : ' + msg);
}
/*function alertError( gl, msg ) {
  var info = gl.getError();
  if (info != gl.NO_ERROR) alert('Error ' + info + ': ' + msg);
}*/
function compileShader( gl, shader, src ) {
  var info;
  gl.shaderSource(shader, src); checkError(gl,'loading shader source ');
  gl.compileShader(shader);
  if ( ! gl.getShaderParameter(shader, gl.COMPILE_STATUS) ) {
    console.log(gl.getShaderInfoLog(shader));
    return null;
  }
  return shader;
}
function attachAttribute( gl, shaderProgram, attributeName ) {
  if ( ! shaderProgram ) console.log('shader is undefined ');

  var attributeLocation = gl.getAttribLocation(shaderProgram, attributeName);
  if (attributeLocation == -1) console.log('cannot get attribute' + attributeName + 'location');

  gl.enableVertexAttribArray(attributeLocation);
  shaderProgram.attribute[attributeName] = attributeLocation;
}
/*
 Główna funkcja tworząca program cieniujący.
 Przed jej wywołaniem, należy zapisać w polach 'vShaderSrc' i 'fShaderSrc' kontekstu gl kody źródłowe obu shaderów.
 */
function initShaders( gl, attribs ) {
  var vshader = gl.createShader(gl.VERTEX_SHADER);   checkError(gl, 'creating vertex shader');
  var fshader = gl.createShader(gl.FRAGMENT_SHADER); checkError(gl, 'creating fragment shader');

  compileShader(gl, vshader, gl.vShaderSrc);
  compileShader(gl, fshader, gl.fShaderSrc);

  var shaderProgram = gl.createProgram();
  checkError(gl, 'creating program');

  gl.attachShader(shaderProgram, vshader); checkError(gl, 'attaching vshader');
  gl.attachShader(shaderProgram, fshader); checkError(gl, 'attaching fshader');

  gl.linkProgram(shaderProgram);
  var info = gl.getProgramParameter(shaderProgram, gl.LINK_STATUS);
  if ( ! info ) {
    console.log('Could not initialise shaders ' + info);
  }
  checkError(gl, 'linking program');

  gl.useProgram(shaderProgram);
  shaderProgram.attribute = {};
  gl.shaderProgram = shaderProgram;
  attribs.forEach( function (name) {
    attachAttribute(gl, shaderProgram, name);
  });
}
/*
 Funkcja  pobiera i zwraca adres zmienne uniform o nazwie 'name' w programie 'shader'.
 Jeśli taka zmienna nie istnieje funkcja wypisuje stosowny komunikat na konsoli.
 */
function getUniformLocation( gl, shader, name ) {
  var uniformLocation = gl.getUniformLocation(shader, name);
  if ( ! uniformLocation ) console.log('could not find uniform ' + name);
  return uniformLocation;
}
/*
 Funkcja tworząca bufor wierzchołków i ładująca do niego dane z tablicy 'data'.
 Parametr 'itemSize' określa ilość współrzędnych, a 'numItems' ilość wierzchołków.
 */
function initArrayBuffer( gl, itemSize, numItems, data ) {
  var buffer = gl.createBuffer();
  gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
  gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(data), gl.STATIC_DRAW);
  return buffer;
}
/*function initElementArrayBuffer(gl, indices) {
    var buffer = gl.createBuffer();
    gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, buffer);
    gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, new Uint16Array(indices), gl.STATIC_DRAW);
    gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, null);
    return buffer;
}*/
function handleLoadedTexture( gl, texture ) {
  gl.activeTexture(gl.TEXTURE0);
  gl.bindTexture(gl.TEXTURE_2D, texture);
  //gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, true);
  console.log(texture.image.height);
  gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGB,gl.RGB,gl.UNSIGNED_BYTE, texture.image);
  //gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGB,  texture.image.width, texture.image.height, 0, gl.RGB, gl.UNSIGNED_BYTE,texture.image);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
  gl.uniform1i(gl.uTexture, 0);
  console.log('loaded texture ' + texture.image.src + ' ' + texture.image.width);
}
function initTexture( gl, src, doAfterImageLoads ) {
  var texture = gl.createTexture();
  texture.image = new Image();
  texture.image.onload = function() {
    handleLoadedTexture(gl, texture);
    doAfterImageLoads(); // callback
  };
  texture.image.src = src;
  return texture;
}



function drawPrepare( gl ) {
  // Tworzenie i załadowanie programu shadera
  if ( ! usePFL ) {
    gl.vShaderSrc = getTextFromTag('vertex-shader-I');
    gl.fShaderSrc = getTextFromTag('fragment-shader-I');
  }
  else {
    gl.vShaderSrc = getTextFromTag('PFL-vertex-shader');
    gl.fShaderSrc = getTextFromTag('PFL-fragment-shader');
  }
  //console.log(gl.fShaderSrc);
  initShaders( gl, ['aPosition', 'aColor', 'aTexture', 'aNormal'] );
  initTexture( gl, 'stones.jpg', drawAll );

  var vertexCoords  = [];
  var colorCoords   = [];
  var textureCoords = [];
  var normalCoords  = [];
  var object;
  for (var i = 0; i < objectsToDraw.length; ++i) {
    object = objectsToDraw[i];
    vertexCoords.push.apply(  vertexCoords,  object.vertexCoords );
    colorCoords.push.apply(   colorCoords,   object.colorCoords );
    textureCoords.push.apply( textureCoords, object.textureCoords );
    normalCoords.push.apply(  normalCoords,  object.normalCoords );
  }
  gl.vertexBuffer  = initArrayBuffer( gl, 3, 1, vertexCoords  );
  gl.colorBuffer   = initArrayBuffer( gl, 4, 1, colorCoords   );
  gl.textureBuffer = initArrayBuffer( gl, 2, 1, textureCoords );
  gl.normalBuffer  = initArrayBuffer( gl, 3, 1, normalCoords  );

  gl.bindBuffer( gl.ARRAY_BUFFER, gl.vertexBuffer );
  gl.vertexAttribPointer(
    gl.shaderProgram.attribute['aPosition'], // location
    3, gl.FLOAT, false, 0, 0 // numComponents, typeOfData, normalizeFlag, strideToNextPieceOfData, offsetIntoBuffer
  );
  gl.bindBuffer( gl.ARRAY_BUFFER, gl.colorBuffer );
  gl.vertexAttribPointer(
    gl.shaderProgram.attribute['aColor'],
    4, gl.FLOAT, false, 0, 0
  );
  gl.bindBuffer( gl.ARRAY_BUFFER, gl.textureBuffer );
  gl.vertexAttribPointer(
    gl.shaderProgram.attribute['aTexture'],
    2, gl.FLOAT, false, 0, 0
  );
  gl.bindBuffer( gl.ARRAY_BUFFER, gl.normalBuffer );
  gl.vertexAttribPointer(
    gl.shaderProgram.attribute['aNormal'],
    3, gl.FLOAT, false, 0, 0
  );

  gl.uMV                       = getUniformLocation( gl, gl.shaderProgram, 'uMV' );
  gl.uMV_normal                = getUniformLocation( gl, gl.shaderProgram, 'uMV_normal' );
  gl.uMVP                      = getUniformLocation( gl, gl.shaderProgram, 'uMVP' );
  gl.uTexture                  = getUniformLocation( gl, gl.shaderProgram, 'uTexture' );
  gl.uAttenuationCoefficient   = getUniformLocation( gl, gl.shaderProgram, 'uAttenuationCoefficient' );
  gl.uLightPositionInViewSpace = getUniformLocation( gl, gl.shaderProgram, 'uLightPositionInViewSpace' );
  gl.uLightColor               = getUniformLocation( gl, gl.shaderProgram, 'uLightColor' );
  gl.uUseSpecular              = getUniformLocation( gl, gl.shaderProgram, 'uUseSpecular' );
  gl.uUseTexture               = getUniformLocation( gl, gl.shaderProgram, 'uUseTexture' );
  gl.uMaterialShininess        = getUniformLocation( gl, gl.shaderProgram, 'uMaterialShininess' );
  gl.uIsLamp                   = getUniformLocation( gl, gl.shaderProgram, 'uIsLamp' );
}
function draw( gl, primitive, offset, count ) {
  gl.drawArrays( primitive, offset, count );
  checkError( gl, 'drawArrays' );
}


function normalize( v ) { return vec3.normalize( v, v ); }
function norm( v )      { return vec3.squaredLength(v); }
function dot( v, u )    { return vec3.dot( v, u ); }
function cross( v, u )  { return vec3.cross( vec3.create(), v, u ); }
function sub( v, u )    { return vec3.sub( vec3.create(), v, u ); }
function sum( v, u )    { return vec3.add( vec3.create(), v, u ); }

// globals
var gl;
var objectsToDraw = [];
var xTranslation = 0.0, yTranslation = 0.0, zTranslation = 0.0,
    xRotation    = 0.0, yRotation    = 0.0, zRotation    = 0.0,
    xyzScaling   = 1.0,
    eyeX    = -1.0, eyeY    = 0.0, eyeZ    = -3.0,
    centerX =  0.0, centerY = 0.0, centerZ =  0.0,
    upX     =  0.0, upY     = 1.0, upZ     =  0.0,
    camRX   = 0.0, camRY   = 0.0,
    fov    = Math.PI / 2,
    aspect = 1.0,
    near   = 1.0,
    far    = 100,
    bindEYEwithCENTER = false,
    usePFL = false,
    useSpecular = false,
    materialShininess = 30.0,
    attenuation = [0.9, 0.0, 0.0],
    lightColor  = [1.0, 1.0, 1.0];
var color_1 = [0.5, 0.0, 0.6, 1.0],
    color_2 = [1.0, 0.0, 0.7, 1.0];

function onLoad() {
  var canvas = document.getElementById('canvas');

  // Pobranie kontekstu WebGL z elementu canvas i ustawienie  obszaru wyświetlania.
  try {
    gl = canvas.getContext('experimental-webgl');
    gl.viewport( 0, 0, canvas.width, canvas.height );
  } catch (e) {
    console.trace();
    //console.log( new Error().stack );
  }
  if ( ! gl ) alert('Failed to get rendering context for WebGL')

  //gl.frontFace(gl.CW);
  //gl.frontFace(gl.CCW);
  //gl.cullFace(gl.BACK);
  //gl.cullFace(gl.FRONT);
  //gl.enable(gl.CULL_FACE);

  gl.clearColor( 0, 0, 0, 0.9 );
  gl.enable(gl.DEPTH_TEST);
  var info;
  if ( (info = gl.getError()) != gl.NO_ERROR ) {
    console.log('Error ' + info);
  }

  estimateVertices();
  drawPrepare(gl);
}

function addObject( coords, glType, translation, lighting, projectionType, description, textured ) {
  var object = {
    'vertexCoords'   : coords.vertexCoords,
    'colorCoords'    : coords.colorCoords,
    'textureCoords'  : coords.textureCoords,
    'normalCoords'   : coords.normalCoords,
    'coordsCount'    : coords.vertexCoords.length / 3,
    'glType'         : glType,
    'lighting'       : lighting,
    'position'       : translation,
    'projectionType' : projectionType,
    'description'    : description,
    'textured'       : textured
  };
  objectsToDraw.push( object );
}
function getArrow( color ) {
  var vertexCoords  = [];
  var colorCoords   = [];
  var textureCoords = [];
  var normalCoords  = [];
  vertexCoords.push.apply(
    vertexCoords,
    [  0.05, 0.0, -1.0,
       0.0,  0.3, -1.0,
      -0.05, 0.0, -1.0 ]
  );
  for (var i = 0; i < vertexCoords.length / 3; ++i)
    colorCoords.push.apply( colorCoords, color );
  textureCoords.push.apply( textureCoords, [0.5, 0.5, 0.5, 0.5, 0.5, 0.5] );
  normalCoords.push.apply( normalCoords, [0, 0, 1, 0, 0, 1, 0, 0, 1] );

  return {
    'vertexCoords'  : vertexCoords,
    'colorCoords'   : colorCoords,
    'textureCoords' : textureCoords,
    'normalCoords'  : normalCoords
  };
}
function getTriangleFanRegularPolygon( v, r, tx, ty, tz ) {
  var vertexCoords  = [];
  var colorCoords   = [];
  var textureCoords = [];
  var normalCoords  = [];

  // border vertices
  for (var i = 0; i < v; ++i) {
    var slc = 2*Math.PI / v;
    var sin = Math.sin(i * slc);
    var cos = Math.cos(i * slc);
    vertexCoords.push( tx + r * cos );
    vertexCoords.push( ty + r * sin );
    vertexCoords.push( tz );
    colorCoords.push.apply( colorCoords, color_1 );
    textureCoords.push( cos );
    textureCoords.push( sin );
    normalCoords.push.apply( normalCoords, [0, 0, 1] );
  }

  // repeat first border vertice as last
  vertexCoords.push( vertexCoords[0] );
  vertexCoords.push( vertexCoords[1] );
  vertexCoords.push( vertexCoords[2] );
  colorCoords.push.apply( colorCoords, color_1 );
  textureCoords.push( Math.cos(i) );
  textureCoords.push( Math.sin(i) );
  normalCoords.push.apply( normalCoords, [0, 0, 1] );

  // adding (so far missing) starting middle point as first
  vertexCoords.unshift.apply( vertexCoords, [tx, ty, tz + 1] );
  colorCoords.unshift.apply( colorCoords, color_2 );
  textureCoords.unshift( 0.5 );
  textureCoords.unshift( 0.5 );
  normalCoords.unshift.apply( normalCoords, [0, 0, 1] );

  return {
    'vertexCoords'  : vertexCoords,
    'colorCoords'   : colorCoords,
    'textureCoords' : textureCoords,
    'normalCoords'  : normalCoords
  };
}
function getLamp( v, tx, ty, tz ) {
  var lamp = getTriangleFanRegularPolygon( v, 0.15, tx, ty, tz );
  lamp[ 'vertexCoords'].forEach( function(e, i, a) { if ((i+1)%3 == 0) { a[i] = tz; } } );
  //lamp[ 'normalCoords'].forEach( function(e, i, a) { a[i] = 0; } );
  lamp['textureCoords'].forEach( function(e, i, a) { a[i] = 0; } );
  lamp[  'colorCoords'].forEach( function(e, i, a) { a[i] = 1; } );
  return lamp;
}

function getLocalCoordinatesSystemDrawing() {
  var lineCoords = [
    0,    0,    0,
    1000, 0,    0,
    0,    0,    0,
    0,    1000, 0,
    0,    0,    0,
    0,    0,    1000
  ];
  var lineColors = [];
  for (var i = 0; i < 6; ++i) lineColors.push.apply(lineColors, color_1);
  return {
    'vertexCoords'  : lineCoords,
    'colorCoords'   : lineColors,
    'textureCoords' : null,
    'normalCoords'  : null
  };
}

function estimateVertices() {
  var v = 27;
  var o1      = getTriangleFanRegularPolygon( v, 0.5, 0, 0, 0 ); // v, r, tx, ty, tz
  var lamp    = getLamp( v, 0, 0, 0 );
  var head    = getArrow( [0.0, 1.0, 0.0, 0.9] );
  var compass = getArrow( [1.0, 0.0, 0.0, 0.9] );
  addObject( o1,      gl.TRIANGLE_FAN, [0, 0, 0], '',     undefined, undefined, true );
  addObject( lamp,    gl.TRIANGLE_FAN, [0, 0, 1], 'lamp', undefined, undefined, false );
  addObject( head,    gl.TRIANGLES,    [0, 0, 0], 'dim',  'ortho',   'head',    false );
  addObject( compass, gl.TRIANGLES,    [0, 0, 0], 'dim',  'ortho',   'compass', false );
  //getCoordinatesSystemDrawing();
}

function drawAll() {
  gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

  gl.uniform3fv( gl.uAttenuationCoefficient, attenuation );
  gl.uniform3fv( gl.uLightColor, lightColor );
  gl.uniform1i( gl.uUseSpecular, useSpecular );
  gl.uniform1f( gl.uMaterialShininess, materialShininess );

  var V = createMVP( mat4.create() ).V;

  var lightPositionInViewSpace = vec4.create();
  var object;
  for (var i = 0; i < objectsToDraw.length; ++i) {
    object = objectsToDraw[i];
    if (object.lighting == 'lamp') { // there is only one lamp
      var lightPositionInWorldSpace = vec4.fromValues(
        object.position[0],
        object.position[1],
        object.position[2],
        1
      );
      vec4.transformMat4( lightPositionInViewSpace, lightPositionInWorldSpace, V );
      break; ////////////////
    }
  }
  gl.uniform4fv( gl.uLightPositionInViewSpace, lightPositionInViewSpace );

  var currentCoord = 0;
  var object;
  for (var i = 0; i < objectsToDraw.length; ++i) {
    object = objectsToDraw[i];
    var matrices = createMVP( createModelMatrix( object.position, undefined, undefined ) );
    var MV = matrices.MV;
    var MV_normal = mat3.create();
    mat3.fromMat4( MV_normal, MV );

    gl.uniformMatrix4fv( gl.uMV,        false, MV );
    gl.uniformMatrix3fv( gl.uMV_normal, false, MV_normal );
    gl.uniform1i( gl.uIsLamp, (object.lighting == 'lamp' || object.lighting == 'dim') ? true : false );
    gl.uniform1i( gl.uUseTexture, object.textured );

    switch (object.projectionType) {
      case 'ortho' : {
        var oV = mat4.create();
        mat4.ortho( oV, -1.0, 1.0, -1.0, 1.0, 0.1, 100.0 );
        mat4.translate( oV, oV, [-0.7, 0.7, 0.0] );
        switch (object.description) {
          case 'head' : {
            //mat4.rotate( oV, oV, -camRY, [0.0, 0.0, 1.0] );
          } break;
          case 'compass' : {
            var agentPosition            = vec3.fromValues( eyeX, eyeY, eyeZ );
            var destinationPosition      = vec3.fromValues( 0, 0, 0 );
            var agentToDestinationVector = normalize( sub( destinationPosition, agentPosition ) );
            var agentVector = vec3.fromValues( V[2], V[6], V[10] );
            console.log(agentVector);
            var angle = Math.atan2(
              norm( cross( agentVector, agentToDestinationVector ) ),
              dot( agentVector, agentToDestinationVector )
            );
            var ry = camRY % (2 * Math.PI);
            if      (ry > Math.PI) angle = Math.PI + (Math.PI - angle);
            else if (ry < 0)       angle = -angle;
            console.log(angle);

            mat4.rotate( oV, oV, angle, [0, 0, 1] );
          } break;
        }
        gl.uniformMatrix4fv( gl.uMVP, false, oV );
      } break;
      case 'billboard' : {

      } break;
      case undefined : {
        var currentMVP = createMVP( createModelMatrix( object.position, undefined, undefined ) );
        gl.uniformMatrix4fv( gl.uMVP, false, currentMVP[ 'MVP' ] );
      } break;
    }

    draw( gl, object.glType, currentCoord, object.coordsCount );
    currentCoord += object.coordsCount;
  }
}

function createModelMatrix( position, rotation, scale ) {
  var tx = (position !== undefined) ? position[0] : 0;
  var ty = (position !== undefined) ? position[1] : 0;
  var tz = (position !== undefined) ? position[2] : 0;
  var rx = (rotation !== undefined) ? rotation[0] : 0;
  var ry = (rotation !== undefined) ? rotation[1] : 0;
  var rz = (rotation !== undefined) ? rotation[2] : 0;
  var sx = (scale    !== undefined) ?    scale[0] : 1;
  var sy = (scale    !== undefined) ?    scale[1] : 1;
  var sz = (scale    !== undefined) ?    scale[2] : 1;

  var M = mat4.create();
  mat4.rotate( M, M, rx + xRotation, [1.0, 0.0, 0.0] );
  mat4.rotate( M, M, ry + yRotation, [0.0, 1.0, 0.0] );
  mat4.rotate( M, M, rz + zRotation, [0.0, 0.0, 1.0] );
  mat4.translate( M, M, [tx + xTranslation, ty + yTranslation, tz + zTranslation] );
  mat4.scale( M, M, [sx * xyzScaling, sy * xyzScaling, sz * xyzScaling] );

  return M;
}
function createMVP( M ) {
  var I          = mat4.create();
  var V          = mat4.create();
  var P          = mat4.create();
  var VP         = mat4.create();
  var VP_inverse = mat4.create();
  var MV         = mat4.create();
  var MVP        = mat4.create();

  mat4.lookAt( V, [0, 0, 0], [centerX, centerY, centerZ], [upX, upY, upZ] );
  mat4.rotate( V, V, camRX, [1.0, 0.0, 0.0] );
  mat4.rotate( V, V, camRY, [0.0, 1.0, 0.0] );
  mat4.translate( V, V, [eyeX, eyeY, eyeZ] );
  mat4.perspective( P, fov, aspect, near, far );
  mat4.mul( MV,  V, M  );
  mat4.mul( MVP, P, MV ); // modelViewProjection (MVP) Matrix = P * (V * M)
  mat4.mul( VP,  P, V  );
  mat4.invert( VP_inverse, VP );

  return {
    'MVP'        : MVP,
    'MV'         : MV,
    'V'          : V,
    'VP'         : VP,
    'VP_inverse' : VP_inverse
  };
}



function initInputs() {
  var textareas = document.querySelectorAll('textarea');
  for (var i = 0; i < textareas.length; ++i) {
    //textareas[i].readonly = 'readonly';
    //textareas[i].contentEditable = 'false';
    textareas[i].disabled = true;
  }
  document.getElementById('slider_1').value = xTranslation;
  document.getElementById('slider_1').parentNode.getElementsByTagName('textarea')[0].value = xTranslation;
  document.getElementById('slider_2').value = yTranslation;
  document.getElementById('slider_2').parentNode.getElementsByTagName('textarea')[0].value = yTranslation;
  document.getElementById('slider_3').value = zTranslation;
  document.getElementById('slider_3').parentNode.getElementsByTagName('textarea')[0].value = zTranslation;
  document.getElementById('slider_19').value = xRotation;
  document.getElementById('slider_19').parentNode.getElementsByTagName('textarea')[0].value = xRotation * Math.PI/180 + ' * PI';
  document.getElementById('slider_20').value = yRotation;
  document.getElementById('slider_20').parentNode.getElementsByTagName('textarea')[0].value = yRotation * Math.PI/180 + ' * PI';
  document.getElementById('slider_4').value = zRotation;
  document.getElementById('slider_4').parentNode.getElementsByTagName('textarea')[0].value = zRotation * Math.PI/180 + ' * PI';
  document.getElementById('slider_5').value = xyzScaling;
  document.getElementById('slider_5').parentNode.getElementsByTagName('textarea')[0].value = xyzScaling;
  updateSliders();
  document.getElementById('fov_slider').value = fov * 180/Math.PI;
  document.getElementById('fov_slider').parentNode.getElementsByTagName('textarea')[0].value = fov / Math.PI + ' * PI';
  document.getElementById('aspect_slider').value = aspect;
  document.getElementById('aspect_slider').parentNode.getElementsByTagName('textarea')[0].value = aspect;
  document.getElementById('near_slider').value = near;
  document.getElementById('near_slider').parentNode.getElementsByTagName('textarea')[0].value = near;
  document.getElementById('far_slider').value = far;
  document.getElementById('far_slider').parentNode.getElementsByTagName('textarea')[0].value = far;
  document.getElementById('slider_21').value = attenuation[0];
  document.getElementById('slider_21').parentNode.getElementsByTagName('textarea')[0].value = attenuation[0];
  document.getElementById('slider_22').value = attenuation[1];
  document.getElementById('slider_22').parentNode.getElementsByTagName('textarea')[0].value = attenuation[1];
  document.getElementById('slider_23').value = attenuation[2];
  document.getElementById('slider_23').parentNode.getElementsByTagName('textarea')[0].value = attenuation[2];
  document.getElementById('R_slider').value = lightColor[0];
  document.getElementById('R_slider').parentNode.getElementsByTagName('textarea')[0].value = lightColor[0];
  document.getElementById('G_slider').value = lightColor[1];
  document.getElementById('G_slider').parentNode.getElementsByTagName('textarea')[0].value = lightColor[1];
  document.getElementById('B_slider').value = lightColor[2];
  document.getElementById('B_slider').parentNode.getElementsByTagName('textarea')[0].value = lightColor[2];
  document.getElementById('slider_27').value = materialShininess;
  document.getElementById('slider_27').parentNode.getElementsByTagName('textarea')[0].value = materialShininess;
  document.getElementById('checkbox_2').checked = false;
  document.getElementById('checkbox_3').checked = false;
}
function attendInput( input ) {
  var id = input.id;
  var val = input.value;
  if (id != 'checkbox_1' && id != 'checkbox_2' && id != 'checkbox_3') {
    var textarea = input.parentNode.getElementsByTagName('textarea')[0]; // why doesn't single nextSibling skip work??
    if (id == 'slider_4' || id == 'slider_19' || id =='slider_20' || id == 'fov_slider') {
      textarea.value = (val / 180).toString() + ' * PI';
    }
    else {
      textarea.value =  val;
    }
  }
  switch (id) {
    case 'slider_1'  : xTranslation = val; break;
    case 'slider_2'  : yTranslation = val; break;
    case 'slider_3'  : zTranslation = val; break;
    case 'slider_19' : xRotation    = val * Math.PI/180; break;
    case 'slider_20' : yRotation    = val * Math.PI/180; break;
    case 'slider_4'  : zRotation    = val * Math.PI/180; break;
    case 'slider_5'  : xyzScaling   = val; break;
    case 'eyeX_slider' :
      eyeX = val;
    break;
    case 'eyeY_slider' :
      eyeY = val;
    break;
    case 'eyeZ_slider' :
      eyeZ = val;
    break;
    case 'centerX_slider' :
      centerX = val;
    break;
    case 'centerY_slider' :
      centerY = val;
    break;
    case 'centerZ_slider' :
      centerZ = val;
    break;
    case 'upX_slider'    : upX    = val; break;
    case 'upY_slider'    : upY    = val; break;
    case 'upZ_slider'    : upZ    = val; break;
    case 'camRX_slider'  : camRX  = val; break;
    case 'camRY_slider'  : camRY  = val; break;
    case 'fov_slider'    : fov    = val * Math.PI/180; break;
    case 'aspect_slider' : aspect = val; break;
    case 'near_slider'   : near   = val; break;
    case 'far_slider'    : far    = val; break;
    case 'slider_21'     : attenuation[0] = val; break;
    case 'slider_22'     : attenuation[1] = val; break;
    case 'slider_23'     : attenuation[2] = val; break;
    case 'R_slider'      : lightColor[0] = val; break;
    case 'G_slider'      : lightColor[1] = val; break;
    case 'B_slider'      : lightColor[2] = val; break;
    case 'slider_27'     : materialShininess = val; break;
    case 'checkbox_1' : bindEYEwithCENTER ^= true; break; 
    case 'checkbox_2' : {
      usePFL ^= true;
      drawPrepare(gl);
    } break;
    case 'checkbox_3' : { useSpecular ^= true; } break;
  }
  drawAll();
}

</script>
</head>

<body onload='onLoad(); initInputs();'>
<div class='panels'>
  <div class='table'>
    <div class='header'> Transformation (Model), for all objects: </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_1' min='-2' max='2' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > xTransl </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_2' min='-2' max='2' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > yTransl </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_3' min='-2' max='2' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > zTransl </input>
      </div>
    </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea id='textarea_19'></textarea>
        <input
          type='range' id='slider_19' min='0' max='360' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > xRot [PI] </input>
      </div>
      <div class='cell'>
        <textarea id='textarea_20'></textarea>
        <input
          type='range' id='slider_20' min='0' max='360' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > yRot [PI] </input>
      </div>
      <div class='cell'>
        <textarea id='textarea_4'></textarea>
        <input
          type='range' id='slider_4' min='0' max='360' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > zRot [PI]</input>
      </div>
    </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_5' min='1' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > xyzScaling </input>
      </div>
    </div>
    <br>
    <div class='header'> Camera (View): </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='eyeX_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > eyeX </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='eyeY_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > eyeY </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='eyeZ_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > eyeZ </input>
      </div>
    </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='centerX_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > centerX </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='centerY_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > centerY </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='centerZ_slider' min='-10' max='10' step='0.1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > centerZ </input>
      </div>
    </div>
    <br>
    <!--<input type='checkbox' id='checkbox_1' onclick='attendInput(this)' unchecked>
      bind EYE with CENTER
    </input>
    <br>-->
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='upX_slider' min='-100' max='100' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > upX </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='upY_slider' min='-100' max='100' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > upY </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='upZ_slider' min='-100' max='100' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > upZ </input>
      </div>
    </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='camRX_slider' min='-90' max='90' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > camRX </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='camRY_slider' min='-90' max='90' step='1' value='0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > camRY </input>
      </div>    
    </div>
    <br>
    <div class='header'> Camera (Projection): </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea id='textarea_15'></textarea>
        <input
          type='range' id='fov_slider' min='-360' max='360' step='0.01' value='90'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > fov (field of view) </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='aspect_slider' min='-10' max='10' step='0.01' value='1'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > aspect </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='near_slider' min='-10' max='10' step='0.1' value='1'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > zNear </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='far_slider' min='-100' max='100' step='1' value='100'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > zFar </input>
      </div>
    </div>
    <br>
    <div class='header'> equation for Attenuation of Light: </div>
    <br>
    <div class='row'>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_21' min='0.0' max='1.0' step='0.1' value='0.3'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > coefficient_1 </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_22' min='0.0' max='1.0' step='0.1' value='1.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > coefficient_2 </input>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_23' min='0.0' max='1.0' step='0.1' value='0.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        > coefficient_3 </input>
      </div>
    </div>
    <br>
    <div> Lights' Color: </div>
    <br>
    <div class='row'>
      <div class='half_cell'>
        <input
          type='range' id='R_slider' min='0.0' max='1.0' step='0.1' value='1.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
          class='vertical'
        ></input>
        <br><br><br><br> R
        <textarea></textarea>
      </div>
      <div class='half_cell'>
        <input
          type='range' id='G_slider' min='0.0' max='1.0' step='0.1' value='1.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
          class='vertical'
        ></input>
        <br><br><br><br> G
        <textarea></textarea>
      </div>
      <div class='half_cell'>
        <input
          type='range' id='B_slider' min='0.0' max='1.0' step='0.1' value='1.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
          class='vertical'
        ></input>
        <br><br><br><br> G
        <textarea></textarea>
      </div>
      <div class='cell'>
        <textarea></textarea>
        <input
          type='range' id='slider_27' min='0.0' max='300.0' step='1.0' value='0.0'
          oninput='attendInput(this)' onchange='attendInput(this)'
        ></input>
        <br>
        Material Shininess (for Specular Lighting)
      </div>
    </div>
  </div>
  <div class='cell'>
    <div class='table'>
      <div class='row'>
        <canvas id='canvas' width='600' height='600'></canvas>
      </div>
      <br>
      <div class='row' style='text-align: center;'>
        <input
          type='checkbox' id='checkbox_2'
          onclick='attendInput(this)' unchecked>
          Per Fragment Lighting
        </input>
        <input
          type='checkbox' id='checkbox_3'
          onclick='attendInput(this)' unchecked>
          Specular
        </input>
      </div>
      <br>
      <div class='row' style='text-align: center; font-size: 1.32em;'>
        - use LEFT MOUSE BUTTON to drag objects on scene! (on the surface of one plane), <br>
        - use W, S, A, D to change observator's position, <br>
        - use RIGHT MOUSE BUTTON to look around.
      </div>
    </div>
  </div>
</div>




<script type='text/javascript'>
function intersects( ray, sphere ) {
  return (
    distance( sphere.center, ray ) < sphere.radius
  );
}
function intersectionPoint( ray, plane ) {
  var rayToPlaneVector  = vec3.create();
  var rayVector_scaled  = vec3.create();
  var intersectionPoint = vec3.create();
  var rayToPlaneVector_dot_planeNormal;
  var rayVector_dot_planeNormal;
  var scaleFactor;
  vec3.sub( rayToPlaneVector, plane.point, ray.source );
  rayToPlaneVector_dot_planeNormal = vec3.dot( rayToPlaneVector, plane.normal );
  rayVector_dot_planeNormal        = vec3.dot( ray.vector, plane.normal );
  scaleFactor                      = rayToPlaneVector_dot_planeNormal / rayVector_dot_planeNormal;
  vec3.scale( rayVector_scaled, ray.vector, scaleFactor );
  vec3.add( intersectionPoint, ray.source, rayVector_scaled );
  return intersectionPoint;
}
function distance( point, ray ) {
  var raysum = vec3.create();
  var d1     = vec3.create();
  var d2     = vec3.create();
  var d1xd2  = vec3.create();
  var triangleAreaTimesTwo;
  var lenghtOfTriangleBase;
  vec3.add( raysum, ray.source, ray.vector );
  vec3.sub( d1, point, ray.source );
  vec3.sub( d2, point, raysum );
  vec3.cross( d1xd2, d1, d2 );
  triangleAreaTimesTwo = vec3.len( d1xd2 );
  lenghtOfTriangleBase = vec3.len( ray.vector );
  return triangleAreaTimesTwo / lenghtOfTriangleBase;
}
function getNormalizedMouseCanvasXY( mouseEvent ) {
  var mouseX = mouseEvent.pageX - canvas.offsetLeft;
  var mouseY = mouseEvent.pageY - canvas.offsetTop;
  var normalizedX =    mouseX / canvas.width  * 2 - 1;
  var normalizedY = - (mouseY / canvas.height * 2 - 1);
  return {
    'x' : normalizedX,
    'y' : normalizedY
  };
}
/* we need to:
   1. reverse VP (multiply by the VP_inverse),
   2. undo perspective divide */
function convertNormalized2DPointToRay( x, y ) {
  function divideByW( vector ) {
    for (var i = 0; i < 3; ++i) vector[i] /= vector[3];
    return vector;
  }
  var VP_inverse = createMVP( mat4.create() ).VP_inverse;
  var positionViewplaneNear = vec4.fromValues( x, y, -1, 1 );
  var positionViewplaneFar  = vec4.fromValues( x, y,  1, 1 );
  var position3Dnear = vec4.create();
  var position3Dfar  = vec4.create();
  var vector         = vec4.create();
  vec4.transformMat4( position3Dnear, positionViewplaneNear, VP_inverse );
  vec4.transformMat4( position3Dfar,  positionViewplaneFar,  VP_inverse );
  position3Dnear = divideByW( position3Dnear );
  position3Dfar  = divideByW( position3Dfar );

  vec4.sub( vector, position3Dfar, position3Dnear );
  return {
    'source' : position3Dnear,
    'vector' : vector
  };
}
function findAndLockClosestObject( ray ) {
  var position;
  var minDist = Number.MAX_VALUE;
  for (var i = 0; i < objectsToDraw.length; ++i) {
    position = vec3.fromValues(
      objectsToDraw[i].position[0],
      objectsToDraw[i].position[1],
      objectsToDraw[i].position[2]
    );
    var radius = 1.0; //////////////////////////////////
    var boundingSphere = {
      'center' : position,
      'radius' : radius
    };
    if ( intersects( ray, boundingSphere ) ) {
      if ( distance( boundingSphere.center, ray ) < minDist ) {
        lockedObject = i;
        break; //////////////////////////////////////////////
      }
    }
  }
  return position;
}
function moveObjectTo( objectID, tx, ty, tz ) {
  if (tx !== undefined) objectsToDraw[objectID].position[0] = tx;
  if (ty !== undefined) objectsToDraw[objectID].position[1] = ty;
  if (tz !== undefined) objectsToDraw[objectID].position[2] = tz;
}

document.oncontextmenu = function(e) { return false; } // disable right mouse button click menu

function findOutPressedMouseButton( e ) {
  if (e.which) {
    if      (e.which   == 1) mouseButtonPressed = 'LEFT';
    else if (e.which   == 3) mouseButtonPressed = 'RIGHT';
    else                     mouseButtonPressed = '';
  }
  /*else if (e.buttons) {
    if      (e.buttons == 1) mouseButtonPressed = 'LEFT';
    else if (e.buttons == 2) mouseButtonPressed = 'RIGHT';
    else                     mouseButtonPressed = 'NONEOTHER';
  }*/
}

var canvas = document.getElementById('canvas');
var lockedObject = -1;
var lockedObjectPosition;
var mouseButtonPressed = '';
var formerX = 0.0, formerY = 0.0;
var x, y;
canvas.onmousedown = function( e ) {
  x = getNormalizedMouseCanvasXY( e ).x;
  y = getNormalizedMouseCanvasXY( e ).y;
  findOutPressedMouseButton( e );

  switch ( mouseButtonPressed ) {
    case 'LEFT' : {
      var ray = convertNormalized2DPointToRay( x, y );
      lockedObjectPosition = findAndLockClosestObject( ray );
    } break;
  }
}
canvas.onmouseup  = function() {
  lockedObject = -1;
  mouseButtonPressed = -1;
}
canvas.onmouseout = function() {
  lockedObject = -1;
  mouseButtonPressed = -1;
}
canvas.onmousemove = function( e ) {
  x = getNormalizedMouseCanvasXY( e ).x;
  y = getNormalizedMouseCanvasXY( e ).y;

  switch ( mouseButtonPressed ) {
    case 'LEFT': {
      if ( lockedObject != -1 ) {
        var ray = convertNormalized2DPointToRay( x, y );
        var plane = {
          'point'  : lockedObjectPosition,
          'normal' : vec3.fromValues( 0, 0, 1 ) ////////////////////////
        }
        var touchedPoint = intersectionPoint( ray, plane );
        moveObjectTo( lockedObject, touchedPoint[0], touchedPoint[1], undefined );
        drawAll();
      }
    } break;
    case 'RIGHT': {
      camRX += (y - formerY) * mouseSpeed;
      camRY += (x - formerX) * mouseSpeed;
      if (camRX >  90*degToRad) camRX =  90*degToRad;
      if (camRX < -90*degToRad) camRX = -90*degToRad;
      updateSliders();
      drawAll();
    } break;
  }
  formerX = x;
  formerY = y;
}

function getTime() {
  //return (new Date()).getTime();
  return window.performance.now();
}

var degToRad = Math.PI / 180.0;
var moveSpeed = 0.01,
    mouseSpeed = 1.0;
var currentTime = 0.0,
    formerTime  = 0.0,
    dt          = 0.0;
document.onkeyup = function() {
  currentTime = 0.0;
  formerTime  = 0.0;
  dt          = 0.0;
}
document.onkeypress = function( e ) {
  currentTime = getTime();
  dt          = currentTime - formerTime;
  if (formerTime == 0.0) dt = 30;
  formerTime  = currentTime;

  var char = e.which || e.keyCode;
  var charCode = String.fromCharCode( char );
  switch ( charCode ) {
    case 'w': {
      eyeX -= Math.sin(camRY) * Math.cos(camRX) * dt * moveSpeed;
      eyeY += Math.sin(camRX) * dt * moveSpeed;
      eyeZ += Math.cos(camRY) * Math.cos(camRX) * dt * moveSpeed;
    } break;
    case 's': {
      eyeX += Math.sin(camRY) * Math.cos(camRX) * dt * moveSpeed;
      eyeY -= Math.sin(camRX) * dt * moveSpeed;
      eyeZ -= Math.cos(camRY) * Math.cos(camRX) * dt * moveSpeed;
    } break;
    case 'a': {
      eyeX += Math.cos(camRY) * dt * moveSpeed;
      eyeZ += Math.sin(camRY) * dt * moveSpeed;
    } break;
    case 'd': {
      eyeX -= Math.cos(camRY) * dt * moveSpeed;
      eyeZ -= Math.sin(camRY) * dt * moveSpeed;
    } break;
  }
  updateSliders();
   
  drawAll();
}




function updateSliders() {
  document.getElementById('eyeX_slider').value = eyeX;
  document.getElementById('eyeX_slider').parentNode.getElementsByTagName('textarea')[0].value = eyeX;
  document.getElementById('eyeY_slider').value = eyeY;
  document.getElementById('eyeY_slider').parentNode.getElementsByTagName('textarea')[0].value = eyeY;
  document.getElementById('eyeZ_slider').value = eyeZ;
  document.getElementById('eyeZ_slider').parentNode.getElementsByTagName('textarea')[0].value = eyeZ;
  document.getElementById('centerX_slider').value = centerX;
  document.getElementById('centerX_slider').parentNode.getElementsByTagName('textarea')[0].value = centerX;
  document.getElementById('centerY_slider').value = centerY;
  document.getElementById('centerY_slider').parentNode.getElementsByTagName('textarea')[0].value = centerY;
  document.getElementById('centerZ_slider').value = centerZ;
  document.getElementById('centerZ_slider').parentNode.getElementsByTagName('textarea')[0].value = centerZ;
  document.getElementById('upX_slider').value = upX;
  document.getElementById('upX_slider').parentNode.getElementsByTagName('textarea')[0].value = upX;
  document.getElementById('upY_slider').value = upY;
  document.getElementById('upY_slider').parentNode.getElementsByTagName('textarea')[0].value = upY;
  document.getElementById('upZ_slider').value = upZ;
  document.getElementById('upZ_slider').parentNode.getElementsByTagName('textarea')[0].value = upZ;
  document.getElementById('camRX_slider').value = camRX;
  document.getElementById('camRX_slider').parentNode.getElementsByTagName('textarea')[0].value = camRX;
  document.getElementById('camRY_slider').value = camRY;
  document.getElementById('camRY_slider').parentNode.getElementsByTagName('textarea')[0].value = camRY;
}
</script>

</body>
</html>
